// NCDApp.cpp: CNCDApp NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "NCDApp.h"
#include "RegNotifyUtil.h"

#define SHELL_STATE_KEY_NAME	_T("System\\State\\Shell")
#define ACTIVE_APP_VAL_NAME		_T("Active Application")
#define CONFIRM_DLG_CLASS		_T("Dialog")
#define CONFIRM_DLG_CAPTION		_T("_CmF@")
#define DENWA_WINDOW_CAPTION	_T("db ")

static
void NotifyCB(
	HANDLE hRegNotify,
	DWORD dwUserData,
	const PBYTE pData,
	const UINT cbData
)
{
	if (pData != NULL) {

		if (_tcsstr((LPTSTR)pData, CONFIRM_DLG_CAPTION) != NULL || _tcsstr((LPTSTR)pData, DENWA_WINDOW_CAPTION) != NULL) {
			
			HWND	hWnd;

			hWnd = GetForegroundWindow();
			if (hWnd != NULL) {
				TCHAR	szClass[32];

				memset(szClass, 0, sizeof(szClass));
				GetClassName(hWnd, szClass, sizeof(szClass)/sizeof(szClass[0]));

				if (_tcscmp(szClass, CONFIRM_DLG_CLASS) == 0) {
					TCHAR	szCaption[32];

					memset(szCaption, 0, sizeof(szCaption));
					GetWindowText(hWnd, szCaption, sizeof(szCaption)/sizeof(szCaption[0]));

					if (_tcscmp(szCaption, CONFIRM_DLG_CAPTION) == 0) {
						PostMessage(hWnd, WM_COMMAND, IDYES, 0);
					}
				}
			}
		}
	}
}


CNCDApp::CNCDApp()
{
	m_bInitialized	= FALSE;
	m_hKey			= NULL;
	m_hRegNotify	= NULL;
}

CNCDApp::~CNCDApp()
{
	if (m_hRegNotify != NULL) {
		this->Stop();
	}
	if (m_bInitialized) {
		this->Terminate();
	}
}

BOOL
CNCDApp::Initialize()
{
	BOOL	bRet;

	bRet = FALSE;

	if (m_bInitialized) {
		return FALSE;
	}

	if (RNUtil_Initialize()) {
		m_bInitialized = TRUE;
		bRet = TRUE;
	}

	return bRet;
}

BOOL
CNCDApp::Terminate()
{
	BOOL	bRet;

	bRet = FALSE;

	if (m_bInitialized) {
		if (m_hRegNotify != NULL) {
			this->Stop();
		}

		RNUtil_Terminate();
		m_bInitialized = FALSE;

		bRet = TRUE;
	}

	return bRet;
}


BOOL
CNCDApp::Start()
{
	BOOL	bRet;
	LONG	lResult;
	HKEY	hKey = NULL;

	bRet = FALSE;

	if (!m_bInitialized) {
		return FALSE;
	}
	if (m_hRegNotify != NULL) {
		return FALSE;
	}

	lResult = RegOpenKeyEx(HKEY_CURRENT_USER, SHELL_STATE_KEY_NAME, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {
		HRESULT	hr;
		HANDLE	hRegNotify = NULL;

		hr = RNUtil_RegistryNotifyCallback(hKey, NULL, ACTIVE_APP_VAL_NAME, NotifyCB, 0, NULL, &hRegNotify);
		if (SUCCEEDED(hr)) {
			m_hKey = hKey;
			m_hRegNotify = hRegNotify;

			bRet = TRUE;
		}
		else {
			RegCloseKey(hKey);
			hKey = NULL;
		}
	}

	return bRet;
}


BOOL
CNCDApp::Stop()
{
	if (!m_bInitialized) {
		return FALSE;
	}

	if (m_hRegNotify != NULL) {
		RNUtil_RegistryCloseNotification(m_hRegNotify);
		m_hRegNotify = NULL;
	}

	if (m_hKey != NULL) {
		RegCloseKey(m_hKey);
		m_hKey = NULL;
	}

	return TRUE;
}


